Subject: Re: [Bug 4554] New: /proc/net/route missing info for 127.0.0.1/8

From: Thomas Graf <[email-masked]>
Date: Wed, 4 May 2005 01:08:24 +0200

* Arnaldo Carvalho de Melo <[email-masked]> 2005-05-03 19:55
> [root@toy acme]# route -n
> Tabela de Roteamento IP do Kernel
> Destino         Roteador        MáscaraGen.    Opções Métrica Ref   Uso Iface
> 192.168.1.0     0.0.0.0         255.255.255.0   U     0      0        0 eth0
> 172.20.0.0      0.0.0.0         255.255.0.0     U     0      0        0 tun0
> 127.0.0.0       0.0.0.0         255.0.0.0       U     0      0        0 lo
> 0.0.0.0         192.168.1.2     0.0.0.0         UG    0      0        0 eth0
> [root@toy acme]# uname -r
> 2.6.11-77124cl
> [root@toy acme]#
> 
> [root@toy acme]# ip r s
> 192.168.1.0/24 dev eth0  proto kernel  scope link  src 192.168.1.192
> 172.20.0.0/16 dev tun0  proto kernel  scope link  src 172.20.0.1
> 127.0.0.0/8 dev lo  scope link
> default via 192.168.1.2 dev eth0

Your distribution, scripts, whatever doesn't use the local table
for the loopback route. This gets to be a problem once you add
fib rules and rely on the fact that local routes should have top
priority.

> [root@toy acme]#
> 
> [root@toy acme]# cat /proc/net/route
> Iface   Destination     Gateway         Flags   RefCnt  Use     Metric
>  Mask            MTU     Window  IRTT
> eth0    0001A8C0        00000000        0001    0       0       0     
>  00FFFFFF        0       0       0
> tun0    000014AC        00000000        0001    0       0       0     
>  0000FFFF        0       0       0
> lo      0000007F        00000000        0001    0       0       0     
>  000000FF        0       0       0
> eth0    00000000        0201A8C0        0003    0       0       0     
>  00000000        0       0       0
> [root@toy acme]#

Yes, that's the main routing table. This is a userspace issue.